#!/usr/bin/python2

####################################################################################################################
##### Script runs mongo operations
#####
##### Syntax: mongo-manager.py  --mode=MODE 
##### 
####################################################################################################################

from subprocess import call ,Popen, PIPE
import time
import string
import random
import os, shutil, logging, sys, re
from optparse import OptionParser, SUPPRESS_HELP 
import urllib

CONST = None
FORWARD_SLASH="/"

class LessThenFilter(logging.Filter):
    def __init__(self, level):
	self._level = level
	logging.Filter.__init__(self)

    def filter(self, rec):
        return rec.levelno < self._level

def setup():
	global logger
	logger = logging.getLogger('mongo_manager')
	logger.setLevel(logging.DEBUG)

	# create a console handler
	cHandler = logging.StreamHandler(sys.stdout)
	cHandler.setLevel(logging.INFO)
	cHandler.setFormatter(logging.Formatter('%(message)s'))
	cHandler.addFilter(LessThenFilter(logging.WARNING))
	logger.addHandler(cHandler)

	# create a console handler for stderr
	ceHandler = logging.StreamHandler()
	ceHandler.setLevel(logging.WARNING)
	ceHandler.setFormatter(logging.Formatter('%(message)s'))
	logger.addHandler(ceHandler)

	# create a file handler
	fHandler = logging.FileHandler(options.log)
	fHandler.setLevel(logging.DEBUG)
	fHandler.setFormatter(logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s'))
	logger.addHandler(fHandler)

	add_wide_gaps() 
	logger.debug('+--------------------------------------------------------------------------------+')
	logger.debug('+----------------------- STARTING MONGO MANAGER  ---------------------------+')
	logger.debug('')
	logger.debug('Current local time: ' + time.asctime(time.localtime(time.time())) ); 
	logger.debug('')
	logger.debug(os.path.realpath(__file__) + ' called with options: ' + options.__str__())

def main():

	group = repo.get_group_name()

        if options.mode == 'passwordreset' : passwordreset(options.name)
        
        if options.mode == 'resetsuperuserpassword' : passwordsuperuserreset()

def add_wide_gaps():
        for num in range(1,5): 
            logger.debug('')

def clean_exit():
        logger.debug('')
        logger.debug('Script completed successfully, Exiting!')
        logger.debug('')
        sys.exit(0)

def failed_exit():
        logger.debug('')
        logger.debug('Script completed with failures ......')
        sys.exit(1)


def passwordreset(username):
        command = '''/usr/bin/mongo --host localhost --port 27017 --username ecxadmin --password Ecx8dmin --authenticationDatabase=ECDB_master ECDB_master --eval 'db.USER.update({"name":"''' + username + '''"}, {  $set: { "passwordExpired":true, "userPassword": "59e7a464cdf12d6d650d1d2575a53fdf4ccd33cd2bab0a206b8f0307f99386c5", "credentialsUpdated": "false","flags":NumberLong(3)}});' '''

        logger.debug('Command: ' + command)
	pobj = Popen(command, bufsize=1, shell=True, stdout=PIPE, stderr=PIPE, cwd='/tmp')
	out, err = pobj.communicate()
    
	logger.debug('Command Returncode : ' + str(pobj.returncode))
	process_command_output(pobj.returncode, out, err)

def passwordsuperuserreset():
        command = '''/usr/bin/mongo --host localhost --port 27017 --username ecxadmin --password Ecx8dmin --authenticationDatabase=ECDB_master ECDB_master --eval 'db.USER.update({"entityId":NumberLong(1000)}, {  $set: { "passwordExpired":true, "userPassword": "59e7a464cdf12d6d650d1d2575a53fdf4ccd33cd2bab0a206b8f0307f99386c5", "credentialsUpdated": "false","flags":NumberLong(3)}});' '''

        logger.debug('Command: ' + command)
	pobj = Popen(command, bufsize=1, shell=True, stdout=PIPE, stderr=PIPE, cwd='/tmp')
	out, err = pobj.communicate()
    
	logger.debug('Command Returncode : ' + str(pobj.returncode))
	process_command_output(pobj.returncode, out, err)

#######k#################
## Process command output 
#########################
def process_command_output(returncode, out, err):

	if returncode == 0:    
        	if out:
			logger.debug('')
            		logger.debug('Command Output :')
            		logger.debug('----------------')
            		logger.debug('')
            		logger.info(out)            
            		clean_exit()
	else:
       		if out:
			logger.debug('')
			logger.debug('Command Output :')
			logger.debug('----------------')
			logger.debug('')
			logger.error(out)

		if err:
			logger.debug('')
			logger.debug('Command Errors :')
			logger.debug('----------------')
			logger.debug('')
			logger.error(err)                

		failed_exit()

######################### 
# Represents product repo
#########################
class Repo:
    'Class for repo type'

    def __init__(self,group_name='ecx'):
        self.group_name  = group_name 
    
    def get_group_name(self):
        return self.group_name


if __name__ == "__main__":

	parser = OptionParser(version='%prog version 1.0')

	usage = "usage: %prog [options]"
	parser = OptionParser(usage=usage)
    
	parser.add_option("--version", help="version")

	parser.add_option("-l","--log",
                      default='/data/log/adminconsole/mongo-manager.log',
                      dest='log',
                      help="Log file location"
                      " [ default: %default ]" )

	parser.add_option("-v", action="count", dest="verbosity", help=SUPPRESS_HELP)

	parser.add_option("--mode", help="Supported modes for mongo manager: passwordreset")

        parser.add_option("--name", help="username to reset");
    

	(options, args) = parser.parse_args()
	
	setup()
	
	if options.mode is None:
		logger.error('')
		logger.error('Mandatory option \'mode\' is missing')
		parser.print_help()
		failed_exit()   

	if options.mode != 'passwordreset' and options.mode != 'resetsuperuserpassword':
		logger.error('')
		logger.error('Invalid \'mode\' specified')
		parser.print_help()
        	sys.exit(1)

        if options.mode == 'passwordreset' and not options.name:
		logger.error('')
		logger.error('Mode \'passwordreset\' requires name option')
		parser.print_help()
        	sys.exit(1)

	if os.path.exists( '/etc/yum.repos.d/catalogic.repo'): repo=Repo('ecx' )
	elif os.path.exists( '/etc/yum.repos.d/spp.repo'):    repo=Repo('spp')
	else:
		repo = None
        	logger.error('Can not detect product type')
		failed_exit()    

	main()
