"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var Observable_1 = require('rxjs/Observable');
require('rxjs/add/operator/map');
require('rxjs/add/operator/catch');
var core_service_1 = require('ng2-catalogic/core/service/core.service');
var emi_service_1 = require('../../emi.service');
var DashboardService = (function () {
    function DashboardService(http, emiService, coreService) {
        this.http = http;
        this.emiService = emiService;
        this.coreService = coreService;
        this.getRpmPackageUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/getrpmpkgs';
        this.getProductInfoUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/getproductinfo';
        this.getHotfixesUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/hotfixes';
        this.getHotfixChangelogUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/hotfix';
    }
    DashboardService.prototype.getRpmPackages = function () {
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.get(this.getRpmPackageUrl, options)
            .map(this.extractDataRpmpackage)
            .catch(this.handleError);
    };
    DashboardService.prototype.getProductInfo = function () {
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.get(this.getProductInfoUrl, options)
            .map(this.extractDataProductinfo)
            .catch(this.handleError);
    };
    DashboardService.prototype.getHotfixes = function () {
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.get(this.getHotfixesUrl, options)
            .map(this.extractInstalledHotfixRpms)
            .catch(this.handleError);
    };
    DashboardService.prototype.getHotfixChangelog = function (hfpackage) {
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var params = new http_1.URLSearchParams();
        params.set('hfpackage', hfpackage);
        var options = new http_1.RequestOptions({ headers: headers, search: params });
        return this.http.get(this.getHotfixChangelogUrl, options)
            .map(this.extractHotfixChangelog)
            .catch(this.handleError);
    };
    DashboardService.prototype.extractInstalledHotfixRpms = function (res) {
        var body = res.json();
        return body.installedhotfixes || {};
    };
    DashboardService.prototype.extractHotfixChangelog = function (res) {
        var body = res.json();
        return body.hotfixchangelog || {};
    };
    DashboardService.prototype.extractDataProductinfo = function (res) {
        var body = res.json();
        return body.productinfo || {};
    };
    DashboardService.prototype.extractDataRpmpackage = function (res) {
        var body = res.json();
        return body.rpmpackage || {};
    };
    DashboardService.prototype.handleError = function (error) {
        // In a real world app, we might use a remote logging infrastructure
        var errMsg;
        if (error instanceof http_1.Response) {
            var body = error.json() || '';
            if (body.message !== undefined && body.message !== null) {
                if (body.message === "SessionId Timeout") {
                    errMsg = "SessionIdTimeout";
                }
                else {
                    var err = body.error || JSON.stringify(body);
                    errMsg = error.status + " - " + (error.statusText || '') + " " + err;
                }
            }
            else {
                var err = body.error || JSON.stringify(body);
                errMsg = error.status + " - " + (error.statusText || '') + " " + err;
            }
        }
        else {
            errMsg = error.message ? error.message : error.toString();
        }
        console.error('DashboardService ==> handleError() ==> ' + errMsg);
        return Observable_1.Observable.throw(errMsg);
    };
    DashboardService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http, emi_service_1.EMIService, core_service_1.CoreService])
    ], DashboardService);
    return DashboardService;
}());
exports.DashboardService = DashboardService;
