"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// Add the RxJS Observable operators.
var core_1 = require('@angular/core');
var router_1 = require('@angular/router');
var Observable_1 = require('rxjs/Observable');
var core_2 = require('@ngx-translate/core');
require('rxjs/add/observable/interval');
var core_service_1 = require('ng2-catalogic/core/service/core.service');
var maputility_service_1 = require('ng2-catalogic/service/maputility.service');
var emi_service_1 = require('./emi.service');
var license_service_1 = require('./license/services/license.service');
var actions_service_1 = require('./actions/services/actions.service');
var EMIComponent = (function () {
    function EMIComponent(router, emiService, coreService, maputil, licenseService, actionsService, translate) {
        var _this = this;
        this.router = router;
        this.emiService = emiService;
        this.coreService = coreService;
        this.maputil = maputil;
        this.licenseService = licenseService;
        this.actionsService = actionsService;
        this.translate = translate;
        this.product_name = 'ECX';
        this.title = 'Appliance Management Interface (EMI)';
        this.showOverview = false;
        this.showAllOverviewItems = true;
        this.showMainContent = false;
        this.sessionTimeoutException = false;
        this.emiSubscriptionErrors = false;
        this.navigationStatus = true;
        this.coreService.setPluginStatus(this.emiService.getPluginName(), this.emiService.getNavigationStatusKey(), true);
        this._navigationStatusSubscription = this.coreService.pluginStatusSubject.subscribe(function (value) {
            _this.currentNavigationStatusValue = _this.maputil.getValue(_this.emiService.getNavigationStatusKey(), value);
            if (_this.currentNavigationStatusValue != undefined) {
                _this.navigationStatus = _this.currentNavigationStatusValue;
            }
        });
        this.emiService.setSystemStatus(true);
        Observable_1.Observable.interval(5000).subscribe(function () {
            if (_this.emiService.getSystemStatus()) {
                _this.getTime();
                _this.getCurrentTimezone();
            }
        });
        this.router.events.subscribe(function (event) {
            if (event instanceof router_1.NavigationEnd) {
                _this.router.url === '/emi/entry'
                    ? _this.showOverviewChangeEvent()
                    : _this.overviewChangeEvent();
            }
        });
    }
    EMIComponent.prototype.ngOnInit = function () {
        if (this.coreService.getSessionId() !== undefined && this.coreService.getSessionId() !== null) {
            console.log('EMIComponent ==> ngOnInit() ==> sessionId defined');
            if (this.emiService.getSessionTimeOutStatus()) {
                this.sessionTimeoutException = true;
                this.emiSubscriptionErrors = true;
            }
            else {
                this.checkLicense();
                this.getCurrentTimezone();
            }
        }
        else {
            console.error('EMIComponent ==> ngOnInit() ==> sessionId NOT defined');
            this.coreService.gotoRoute("/entry");
        }
    };
    EMIComponent.prototype.getCurrentTimezone = function () {
        var _this = this;
        this.actionsService.getCurrentTimezone()
            .subscribe(function (commandoutput) {
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                _this.emiService.setCurrentTimeZone(commandoutput.commandOutput);
                _this.currentTimezone = _this.emiService.getCurrentTimezone();
            }
        }, function (error) {
            _this.errorMessage = error;
            console.error('EMIComponent ==> getCurrentTimezone() ==> ' + _this.errorMessage);
        });
    };
    EMIComponent.prototype.checkLicense = function () {
        var _this = this;
        this.licenseService.checkLicense()
            .subscribe(function (filedetails) {
            if (filedetails.doesFileExist) {
                //Show overview and all items.
                _this.showOverview = true;
            }
            else {
                //Show overview and force to access only the install license item.
                _this.showOverview = true;
                _this.showAllOverviewItems = false;
            }
        }, function (error) {
            _this.errorMessage = error;
            console.error('EMIComponent ==> checkLicense() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.emiSubscriptionErrors = true;
        });
    };
    EMIComponent.prototype.ngOnDestroy = function () {
        this._navigationStatusSubscription.unsubscribe();
    };
    EMIComponent.prototype.overviewChangeEvent = function () {
        this.showOverview = false;
        this.showMainContent = true;
    };
    EMIComponent.prototype.showOverviewChangeEvent = function () {
        if (this.emiService.getSessionTimeOutStatus()) {
            this.showOverview = false;
        }
        else {
            this.showOverview = true;
        }
        this.showMainContent = false;
    };
    EMIComponent.prototype.getTime = function () {
        var _this = this;
        this.emiService.getDateTime()
            .subscribe(function (apptimestamp) {
            _this.localDateTime = apptimestamp.toString();
        }, function (error) {
            _this.errorMessage = error;
            console.error('EMIComponent ==> getTime() ==> ' + _this.errorMessage);
        });
    };
    EMIComponent.prototype.getProductName = function () {
        return this.emiService.getProductName();
    };
    EMIComponent.prototype.getCompanyName = function () {
        return this.emiService.getCompanyName();
    };
    EMIComponent.prototype.getShowManageUpdatesStatus = function () {
        return this.emiService.showManageUpdates;
    };
    EMIComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'my-app',
            templateUrl: 'emi.component.html'
        }), 
        __metadata('design:paramtypes', [router_1.Router, emi_service_1.EMIService, core_service_1.CoreService, maputility_service_1.MapUtilityService, license_service_1.LicenseService, actions_service_1.ActionsService, core_2.TranslateService])
    ], EMIComponent);
    return EMIComponent;
}());
exports.EMIComponent = EMIComponent;
