"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var Observable_1 = require('rxjs/Observable');
require('rxjs/add/operator/catch');
require('rxjs/add/operator/map');
require('rxjs/add/observable/throw');
var core_service_1 = require('ng2-catalogic/core/service/core.service');
var maputility_service_1 = require('ng2-catalogic/service/maputility.service');
var EMIService = (function () {
    function EMIService(maputil, http, coreService) {
        this.maputil = maputil;
        this.http = http;
        this.coreService = coreService;
        this.pluginname = "emi";
        this.navigationstatuskey = this.pluginname + 'navigationstatuskey';
        this.adminconsolePluginName = "adminconsoleui";
        this.adminconsoleNavigationStatusKey = this.adminconsolePluginName + 'navigationstatuskey';
        //Self-Update available (or) not
        this.selfupdateStatus = false;
        this.showManageUpdates = false;
        this.sessionTimedOut = false;
        this.systemActive = false;
        this.init();
    }
    EMIService.prototype.init = function () {
        this.relativeModulePath = module.id.substring(0, module.id.lastIndexOf("/"));
        this.emiClientUrl = this.coreService.getCookie("adminconsole_emims_url");
        this.adminconsoleUrl = this.coreService.getCookie("adminconsole_ms_url");
        this.oemProductName = this.coreService.getCookie("adminconsole_product_name");
        this.oemCompanyName = this.coreService.getCookie("adminconsole_company_name");
        this.portalUrl = this.coreService.getCookie("adminconsole_portal_url");
        console.log('EMIService => init() ==> System Admin MS URL: ' + this.emiClientUrl);
        console.log('EMIService => init() ==> Product URL: ' + this.portalUrl);
        console.log('EMIService => init() ==> Product Name: ' + this.oemProductName);
        console.log('EMIService => init() ==> Company Name: ' + this.oemCompanyName);
    };
    /*
     * Self Update
     */
    EMIService.prototype.checkSelfupdateAvailable = function () {
        this.checkSelfUpdateUrl = this.getAdminconsoleEmiEndpointsUrl() + '/api/checkselfupdate';
        return this.http.get(this.checkSelfUpdateUrl)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    /**
     * GETTERS
     */
    EMIService.prototype.getServiceUrl = function () {
        return this.emiClientUrl;
    };
    EMIService.prototype.getAdminconsoleUrl = function () {
        return this.adminconsoleUrl;
    };
    EMIService.prototype.getAdminconsoleEmiEndpointsUrl = function () {
        return this.adminconsoleUrl + '/emi';
    };
    EMIService.prototype.getSessionIdHeader = function () {
        return 'x-ac-sessionid';
    };
    EMIService.prototype.getAdminconsoleEmiEndpointsUrlLargeFileUpload = function () {
        return this.adminconsoleUrl + '/zuul/emi';
    };
    EMIService.prototype.getSessionIdTimeoutError = function () {
        return 'SessionIdTimeout';
    };
    EMIService.prototype.getPluginName = function () {
        return this.pluginname;
    };
    EMIService.prototype.getPortalUrl = function () {
        return this.portalUrl;
    };
    EMIService.prototype.getNavigationStatusKey = function () {
        return this.navigationstatuskey;
    };
    EMIService.prototype.getAdminconsoleNavigationStatusKey = function () {
        return this.adminconsoleNavigationStatusKey;
    };
    EMIService.prototype.getDateTime = function () {
        this.dateTimeUrl = this.getAdminconsoleEmiEndpointsUrl() + '/api/getdatetime';
        var headers = new http_1.Headers();
        headers.append('Content-Type', 'application/json');
        headers.append('Accept', 'application/json');
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.get(this.dateTimeUrl, options)
            .map(this.extractDataDateTime)
            .catch(this.handleError);
    };
    EMIService.prototype.getProductName = function () {
        return this.oemProductName;
    };
    EMIService.prototype.getCompanyName = function () {
        return this.oemCompanyName;
    };
    EMIService.prototype.getSelfupdateStatus = function () {
        return this.selfupdateStatus;
    };
    EMIService.prototype.getSessionTimeOutStatus = function () {
        return this.sessionTimedOut;
    };
    EMIService.prototype.getCurrentTimezone = function () {
        return this.currentTimezone;
    };
    EMIService.prototype.getSystemStatus = function () {
        return this.systemActive;
    };
    /**
     * SETTERS
     */
    EMIService.prototype.setSelfupdateStatus = function (status) {
        this.selfupdateStatus = status;
        this.showManageUpdates = true;
    };
    EMIService.prototype.setSessionTimedOut = function () {
        this.sessionTimedOut = true;
        this.deleteBackendSessionId();
    };
    EMIService.prototype.setCurrentTimeZone = function (timezone) {
        this.currentTimezone = timezone;
    };
    EMIService.prototype.setSystemStatus = function (systemStatus) {
        this.systemActive = systemStatus;
    };
    /**
     * EXTRACT DATA
     */
    EMIService.prototype.extractData = function (res) {
        var body = res.json();
        return body || {};
    };
    EMIService.prototype.extractDataDateTime = function (res) {
        var body = res.json();
        return body.apptimestamp || {};
    };
    EMIService.prototype.extractDataCommandOutput = function (res) {
        var body = res.json();
        return body.commandoutput || {};
    };
    /**
     * ERROR HANDLERS
     */
    EMIService.prototype.handleError = function (error) {
        // In a real world app, we might use a remote logging infrastructure
        var errMsg;
        if (error instanceof http_1.Response) {
            var body = error.json() || '';
            var err = body.error || JSON.stringify(body);
            errMsg = error.status + " - " + (error.statusText || '') + " " + err;
        }
        else {
            errMsg = error.message ? error.message : error.toString();
        }
        console.error('EMIService => handleError() ==> ' + errMsg);
        return Observable_1.Observable.throw(errMsg);
    };
    EMIService.prototype.capitalizeFirstLetterLowerRest = function (value) {
        return value.charAt(0).toUpperCase() + value.slice(1).toLowerCase();
    };
    EMIService.prototype.deleteBackendSessionId = function () {
        var deleteSessionUrl = this.coreService.getCookie("adminconsole_ms_url") + '/emi/api/deletesession';
        var headers = new http_1.Headers();
        headers.append('x-ac-sessionid', this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        this.http.post(deleteSessionUrl, null, options)
            .map(this.extractData)
            .catch(this.handleError)
            .subscribe({ error: function (e) { return console.error('EMIService => deleteBackendSessionId ==> SUBSCRIBE ERROR' + e); } });
    };
    EMIService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [maputility_service_1.MapUtilityService, http_1.Http, core_service_1.CoreService])
    ], EMIService);
    return EMIService;
}());
exports.EMIService = EMIService;
