"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var Observable_1 = require('rxjs/Observable');
var core_service_1 = require('ng2-catalogic/core/service/core.service');
require('rxjs/add/operator/map');
require('rxjs/add/operator/catch');
var emi_service_1 = require('../../emi.service');
var NetconfigService = (function () {
    function NetconfigService(http, emiService, coreService) {
        this.http = http;
        this.emiService = emiService;
        this.coreService = coreService;
        this.netconfigUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/netconfig';
        this.updateHostnameUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/hostname';
        this.manageAppUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/manageapp';
    }
    NetconfigService.prototype.getNetconfigModel = function () {
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.get(this.netconfigUrl, options)
            .map(this.extractDataNetconfigModel)
            .catch(this.handleError);
    };
    NetconfigService.prototype.updateHostname = function (hostname) {
        var formData = new FormData();
        formData.append('hostname', hostname);
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.post(this.updateHostnameUrl, formData, options)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    NetconfigService.prototype.updateNetconfig = function (netconfigModel) {
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        var observable = this.http.post(this.netconfigUrl, netconfigModel, options)
            .map(this.extractDataCommandOutput);
        observable
            .catch(this.handleError)
            .subscribe({ error: function (e) { return console.error('NetconfigService ==> updateNetconfig() ==> ' + e); } });
        return observable;
    };
    NetconfigService.prototype.restartProduct = function () {
        var formData = new FormData();
        formData.append('appaction', 'restartapp');
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.post(this.manageAppUrl, formData, options)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError)
            .subscribe({ error: function (e) { return console.error('NetconfigService ==> restartProduct() ==> ' + e); } });
    };
    NetconfigService.prototype.extractDataCommandOutput = function (res) {
        var body = res.json();
        return body.commandoutput || {};
    };
    NetconfigService.prototype.extractDataNetconfigModel = function (res) {
        var body = res.json();
        return body || {};
    };
    NetconfigService.prototype.handleError = function (error) {
        // In a real world app, we might use a remote logging infrastructure
        var errMsg = NetconfigService.mapToErrorMessage(error);
        console.error('NetconfigService ==> handleError() ==> ' + errMsg);
        return Observable_1.Observable.throw(errMsg);
    };
    NetconfigService.mapToErrorMessage = function (error) {
        var errMsg;
        if (error instanceof http_1.Response) {
            var body = error.json() || '';
            if (body.message !== undefined && body.message !== null) {
                if (body.message === "SessionId Timeout") {
                    errMsg = "SessionIdTimeout";
                }
                else {
                    var err = body.error || JSON.stringify(body);
                    errMsg = error.status + " - " + (error.statusText || '') + " " + err;
                }
            }
            else {
                var err = body.error || JSON.stringify(body);
                errMsg = error.status + " - " + (error.statusText || '') + " " + err;
            }
        }
        else {
            errMsg = error.message ? error.message : error.toString();
        }
        return errMsg;
    };
    NetconfigService.mapToRootErrorMessage = function (error) {
        var errMsg;
        if (error instanceof http_1.Response) {
            var body = error.json() || '';
            if (body.message !== undefined && body.message !== null) {
                if (body.message === "SessionId Timeout") {
                    errMsg = "SessionIdTimeout";
                }
                else {
                    var err = body.error || JSON.stringify(body);
                    errMsg = body.message;
                }
            }
            else {
                errMsg = body.message;
            }
        }
        else {
            errMsg = error.message ? error.message : error.toString();
        }
        return errMsg;
    };
    NetconfigService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http, emi_service_1.EMIService, core_service_1.CoreService])
    ], NetconfigService);
    return NetconfigService;
}());
exports.NetconfigService = NetconfigService;
