"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var core_2 = require('@ngx-translate/core');
var Observable_1 = require('rxjs/Observable');
require('rxjs/add/observable/interval');
var core_service_1 = require('ng2-catalogic/core/service/core.service');
var maputility_service_1 = require('ng2-catalogic/service/maputility.service');
var confirmation_component_1 = require('ng2-catalogic/confirmation/confirmation.component');
var productupdates_service_1 = require('../services/productupdates.service');
var actions_service_1 = require('../../actions/services/actions.service');
var emi_service_1 = require('../../emi.service');
var ProductUpdatesComponent = (function () {
    function ProductUpdatesComponent(coreService, productUpdatesService, actionsService, emiService, maputil, translate) {
        var _this = this;
        this.coreService = coreService;
        this.productUpdatesService = productUpdatesService;
        this.actionsService = actionsService;
        this.emiService = emiService;
        this.maputil = maputil;
        this.translate = translate;
        this.isOSUpdate = false;
        this.showUpdateAvailabilityCmdResponseWindow = false;
        this.updateAvailabilityCmdSuccess = false;
        this.ecxUpdateCmdSuccess = false;
        this.showEcxUpdateCmdResponseWindow = false;
        this.productRestartAfterUpdateRunning = false;
        this.productRestartedAfterUpdate = false;
        this.productRestartAfterUpdateFailure = false;
        this.ecxUpdateRunning = false;
        this.checkUpdateRunning = false;
        this.checkUpdateDone = false;
        this.ecxUpdateDone = false;
        this.osUpdateRunning = false;
        this.osUpdateDone = false;
        this.osUpdateCmdSuccess = false;
        this.showOsUpdateCmdResponseWindow = false;
        this.productStatusCheckRunning = false;
        this.productStatusCheckFailure = false;
        this.productIsRunning = false;
        this.productStopRunning = false;
        this.productIsStopped = false;
        this.productStopFailure = false;
        this.uploadUpdateImageButtonState = true;
        this.showNoInternetDialog = false;
        this.showNoInternetDialogUploadForm = false;
        this.showNoInternetUploadStatus = false;
        this.showNoInternetUploadRunning = false;
        this.showNoInternetUploadSuccess = false;
        this.showNoInternetUploadFailure = false;
        this.showInternetDialog = false;
        this.showNoInternetCleanupRunning = false;
        this.showNoInternetCleanupSuccess = false;
        this.showNoInternetCleanupFailure = false;
        this.checkingInternetConnectivity = false;
        //SELF-UPDATE
        this.selfUpdateAvailable = false;
        this.selfUpdateRunning = false;
        this.selfUpdateRestart = false;
        this.applicationName = "Administrative Console";
        this.showNoInternetDialogUploadFormDefaultHeader = true;
        //This is added to run the update cleanup process during manual update
        this.manualUpdateProcess = false;
        this.isNoInternetChecked = true;
        this.isInternetChecked = false;
        this.updateSubscriptionErrors = false;
        this.sessionTimeoutException = false;
        this.rebootAppliance = false;
        this.applianceRebootAfterUpdateRunning = false;
        this.applianceRebootedAfterUpdate = false;
        this.applianceRebootedAfterUpdateFailure = false;
        //HOTFIXES
        this.isHotfixDeployment = false;
        this.hotfixDeploymentStarted = false;
        this.hotfixDeploymentRunning = false;
        this.hotfixDeploymentFailure = false;
        this.hotfixDeploymentSuccess = false;
        this.productRestartAfterHotfixDeployRunning = false;
        this.productRestartedAfterHotfixDeploy = false;
        this.productRestartAfterHotfixDeployFailed = false;
        this.updatesAvailable = false;
        this.updateVersions = [];
        this.confirmUpdateIcon = "cloud download";
        this.subs = [];
        this.productName = this.getProductName();
        this.navigationStatus = true;
        this._navigationStatusSubscription = this.coreService.pluginStatusSubject.subscribe(function (value) {
            _this.currentNavigationStatusValue = _this.maputil.getValue(_this.emiService.getNavigationStatusKey(), value);
            if (_this.currentNavigationStatusValue != undefined) {
                _this.navigationStatus = _this.currentNavigationStatusValue;
            }
        });
        this.progressString = [];
    }
    ProductUpdatesComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.emiService.getSessionTimeOutStatus()) {
            this.sessionTimeoutException = true;
            this.updateSubscriptionErrors = true;
        }
        else {
            this.selfUpdateAvailable = this.emiService.getSelfupdateStatus();
            this.checkInternet();
        }
        this.subs.push(this.translate.get(['UPDATES.MODAL_UPDATE_HEADER',
            'UPDATES.MODAL_MANUAL_UPDATE_HEADER',
            'UPDATES.MODAL_UPDATE_MESSAGE',
            'UPDATES.CONTACT_UPDATE_SERVER',
            'UPDATES.STARTING_PRODUCT_UPDATE',
            'UPDATES.STARTING_OS_UPDATE',
            'UPDATES.STARTED_PRODUCT_UPDATE',
            'UPDATES.INITIALIZE_PRODUCT_UPDATE',
            'UPDATES.INITIALIZE_OS_UPDATE',
            'UPDATES.ERRORS_UPLOAD',
            'UPDATES.MODAL_MANUAL_UPDATE_MESSAGE',
            'UPDATES.ERRORS_PRODUCT_STATE',
            'UPDATES.ERRORS_PRODUCT_UPDATE',
            'UPDATES.ERRORS_STOP_PRODUCT',
            'UPDATES.ERRORS_REBOOT_VA',
            'UPDATES.ERRORS_RESTART_PRODUCT',
            'UPDATES.ERRORS_CHECK_UPDATES',
            'UPDATES.ERRORS_DEPLOY_HOTFIX',
            'UPDATES.ERRORS_CLEANUP',
            'UPDATES.ERRORS_INTERNET_CONNECTIVITY',
            'UPDATES.YES',
            'UPDATES.NO'
        ], { productName: this.productName })
            .subscribe(function (resource) {
            _this.confirmUpdateHeader = resource['UPDATES.MODAL_UPDATE_HEADER'];
            _this.confirmManualUpdateHeader = resource['UPDATES.MODAL_MANUAL_UPDATE_HEADER'];
            _this.confirmUpdateMessage = resource['UPDATES.MODAL_UPDATE_MESSAGE'];
            _this.contactUpdateServer = resource['UPDATES.CONTACT_UPDATE_SERVER'];
            _this.startingProductUpdate = resource['UPDATES.STARTING_PRODUCT_UPDATE'];
            _this.startingOsUpdate = resource['UPDATES.STARTING_OS_UPDATE'];
            _this.startedProductUpdate = resource['UPDATES.STARTED_PRODUCT_UPDATE'];
            _this.initializeProductUpdate = resource['UPDATES.INITIALIZE_PRODUCT_UPDATE'];
            _this.initializeOsUpdate = resource['UPDATES.INITIALIZE_OS_UPDATE'];
            _this.errorMsgUpload = resource['UPDATES.ERRORS_UPLOAD'];
            _this.confirmManualUpdateMessage = resource['UPDATES.MODAL_MANUAL_UPDATE_MESSAGE'];
            _this.errorMsgProductState = resource['UPDATES.ERRORS_PRODUCT_STATE'];
            _this.errorMsgProductUpdate = resource['UPDATES.ERRORS_PRODUCT_UPDATE'];
            _this.errorMsgStopProduct = resource['UPDATES.ERRORS_STOP_PRODUCT'];
            _this.errorMsgRebootVa = resource['UPDATES.ERRORS_REBOOT_VA'];
            _this.errorMsgRestartProduct = resource['UPDATES.ERRORS_RESTART_PRODUCT'];
            _this.errorMsgCheckUpdates = resource['UPDATES.ERRORS_CHECK_UPDATES'];
            _this.errorMsgDeployHotfix = resource['UPDATES.ERRORS_DEPLOY_HOTFIX'];
            _this.errorMsgCleanup = resource['UPDATES.ERRORS_CLEANUP'];
            _this.errorMsgInternetConnec = resource['UPDATES.ERRORS_INTERNET_CONNECTIVITY'];
            _this.yesMessage = resource['UPDATES.YES'];
            _this.noMessage = resource['UPDATES.NO'];
        }, function (error) {
            _this.errorMessage = error;
            console.error('ProductUpdatesComponent ==> Error getting i18n values ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.customUpdateErrorMessage = "Errors initializing component. Please contact product support.";
            _this.updateSubscriptionErrors = true;
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
        }));
    };
    ProductUpdatesComponent.prototype.ngOnDestroy = function () {
        this._navigationStatusSubscription.unsubscribe();
    };
    ProductUpdatesComponent.prototype.confirmOnUpdate = function (version) {
        this.selectedVersion = version;
        this.confirmUpdateDialog.showConfirmationDialog();
    };
    ProductUpdatesComponent.prototype.confirmOnManualUpdate = function () {
        this.confirmManualUpdateDialog.showConfirmationDialog();
    };
    ProductUpdatesComponent.prototype.initWebsocket = function (socketType) {
        var _this = this;
        console.log('ProductUpdatesComponent ==> initWebsocket ==> ' + socketType);
        if (socketType === 'product') {
            this.progressString.push(this.initializeProductUpdate);
        }
        else if (socketType === 'os') {
            this.progressString.push(this.initializeOsUpdate);
        }
        this.socket = this.productUpdatesService.openSocket(socketType);
        this.socket.getSubject().subscribe({
            next: function (v) {
                _this.progressString.push(v.output);
            }
        });
    };
    ProductUpdatesComponent.prototype.getProductName = function () {
        return this.emiService.getProductName();
    };
    ProductUpdatesComponent.prototype.getCompanyName = function () {
        return this.emiService.getCompanyName();
    };
    ProductUpdatesComponent.prototype.fileChangeEventUpdate = function (event) {
        this.updateFilesToUpload = event.target.files;
        if (this.updateFilesToUpload.length > 0) {
            this.uploadUpdateImageButtonState = false;
        }
    };
    /**
     * BASED ON RESPONSE FROM THE API THAT UPLOADS THE UPDATE IMAGE (OR) OS UPDATE IMAGE (OR) HOTFIX THIS FUNCTION
     * CALLS APPROPRIATE FUNCTIONS TO HANDLE EACH USE CASE
     * ERRORCODE:
     *      0   ==> PRODUCT UPDATE
     *      100 ==> OS UPDATE
     *      200 ==> HOTFIX DEPLOYMENT
     */
    ProductUpdatesComponent.prototype.manageUpdateImage = function () {
        var _this = this;
        console.log('ProductUpdatesComponent ==> manageUpdateImage() ==>');
        this.coreService.setPluginStatus(this.emiService.getPluginName(), this.emiService.getNavigationStatusKey(), false);
        this.coreService.setPluginStatus(this.emiService.getPluginName(), this.emiService.getAdminconsoleNavigationStatusKey(), false);
        this.manualUpdateProcess = true;
        var file = this.updateFilesToUpload[0];
        this.productUpdatesService.uploadUpdateImage(file)
            .subscribe(function (commandoutputupdateimage) {
            _this.showNoInternetUploadRunning = false;
            _this.errorCode = commandoutputupdateimage.errorCode;
            _this.updateImageFilename = commandoutputupdateimage.imageFilename;
            _this.updateImageDirectory = commandoutputupdateimage.imageDirectory;
            if (_this.errorCode === "0") {
                _this.showNoInternetUploadSuccess = true;
                _this.manageECXUpdate();
            }
            else if (_this.errorCode === "200") {
                _this.showNoInternetUploadSuccess = true;
                _this.isHotfixDeployment = true;
                _this.manageHotfixDeployment();
            }
            else {
                console.error('ProductUpdatesComponent ==> manageUpdateImage() ==> ' + _this.errorCode);
                console.error('ProductUpdatesComponent ==> manageUpdateImage() ==> Command Output:  ' + commandoutputupdateimage.commandOutput);
                console.error('ProductUpdatesComponent ==> manageUpdateImage() ==> Command Error Output:  ' + commandoutputupdateimage.commandErrorOutput);
                _this.showNoInternetUploadFailure = true;
                _this.showNoInternetUploadFailureMessage = commandoutputupdateimage.commandErrorOutput;
                _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
                _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
            }
        }, function (error) {
            _this.showNoInternetUploadRunning = false;
            _this.errorMessage = error;
            console.error('ProductUpdatesComponent ==> manageUpdateImage() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.customUpdateErrorMessage = _this.errorMsgUpload;
            if (!!_this.errorMessage)
                _this.customUpdateErrorMessage = _this.errorMessage;
            _this.updateSubscriptionErrors = true;
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
        });
        this.showNoInternetDialogUploadForm = false;
        this.showNoInternetUploadStatus = true;
        this.showNoInternetUploadRunning = true;
    };
    ProductUpdatesComponent.prototype.manageHotfixDeployment = function () {
        var _this = this;
        console.log('ProductUpdatesComponent ==> manageHotfixDeployment() ==>');
        this.updateActionsType = "appstatus";
        this.productStatusCheckRunning = true;
        this.actionsService.manageAppService(this.updateActionsType)
            .subscribe(function (commandoutput) {
            _this.errorCode = commandoutput.errorCode;
            _this.productStatusCheckRunning = false;
            if (_this.errorCode === "0") {
                _this.productIsRunning = true;
                _this.stopAndDeployHotfix();
            }
            else {
                _this.deployHotfix();
            }
        }, function (error) {
            _this.productStatusCheckRunning = false;
            _this.errorMessage = error;
            console.error('ProductUpdatesComponent ==> manageHotfixDeployment() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.customUpdateErrorMessage = _this.errorMsgProductState;
            _this.updateSubscriptionErrors = true;
            if (_this.manualUpdateProcess) {
                console.log('ProductUpdatesComponent => manageHotfixDeployment() ==> Running cleanup for manual update process');
                _this.manualUpdateCleanup();
            }
            else {
                _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
                _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
            }
        });
    };
    ProductUpdatesComponent.prototype.manageOSUpdate = function () {
        var _this = this;
        console.log('ProductUpdatesComponent ==> manageOSUpdate() ==>');
        this.initWebsocket('os');
        this.osUpdateRunning = true;
        this.productUpdatesService.startOsUpdate()
            .subscribe(function (commandoutput) {
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                console.info('ProductUpdatesComponent ==> manageOSUpdate() ==> completed.');
                _this.showOsUpdateCmdResponseWindow = true;
                _this.osUpdateCmdSuccess = true;
                _this.osUpdateCmdOutputMessage = commandoutput.commandOutput;
                _this.osUpdateDone = true;
                if (_this.manualUpdateProcess) {
                    console.log('ProductUpdatesComponent ==> manageOSUpdate() ==> Running cleanup for manual update process');
                    _this.manualUpdateCleanup();
                }
                else {
                    _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
                    _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
                }
            }
            else {
                _this.showOsUpdateCmdResponseWindow = true;
                console.error('ProductUpdatesComponent ==> manageOSUpdate() ==> ' + _this.errorCode);
                console.error('ProductUpdatesComponent ==> manageOSUpdate() ==> Command Output: ' + commandoutput.commandOutput);
                console.error('ProductUpdatesComponent ==> manageOSUpdate() ==> Command Error Output: ' + commandoutput.commandErrorOutput);
                _this.osUpdateCmdOutputErrorMessage = commandoutput.commandErrorOutput;
                if (_this.manualUpdateProcess) {
                    console.log('ProductUpdatesComponent ==> manageOSUpdate() ==> Running cleanup for manual update process');
                    _this.manualUpdateCleanup();
                }
                else {
                    _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
                    _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
                }
            }
        }, function (error) {
            _this.errorMessage = error;
            console.error('ProductUpdatesComponent ==> manageOSUpdate() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.customUpdateErrorMessage = _this.errorMsgProductUpdate;
            _this.updateSubscriptionErrors = true;
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
            if (_this.manualUpdateProcess) {
                console.log('ProductUpdatesComponent => manageOSUpdate() ==> Running cleanup for manual update process');
                _this.manualUpdateCleanup();
            }
        });
        this.progressString.push(this.startingOsUpdate);
    };
    ProductUpdatesComponent.prototype.manageECXUpdate = function () {
        if (!this.manualUpdateProcess) {
            this.checkUpdateRunning = false;
            this.coreService.setPluginStatus(this.emiService.getPluginName(), this.emiService.getNavigationStatusKey(), false);
            this.coreService.setPluginStatus(this.emiService.getPluginName(), this.emiService.getAdminconsoleNavigationStatusKey(), false);
        }
        this.updateECX();
    };
    /**
     * FUNCTION STOPS THE PRODUCT AND DEPLOYS HOTFIXES
     */
    ProductUpdatesComponent.prototype.stopAndDeployHotfix = function () {
        var _this = this;
        this.productStopRunning = true;
        this.updateActionsType = "stopapp";
        this.actionsService.manageAppService(this.updateActionsType)
            .subscribe(function (commandoutput) {
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                _this.productIsStopped = true;
                console.log('ProductUpdatesComponent ==> stopAndDeployHotfix() ==> Product stopped. Waiting 5 sec.');
                Observable_1.Observable.interval(5000).take(1).subscribe(function () {
                    _this.productStopRunning = false;
                    console.log('ProductUpdatesComponent ==> stopAndDeployHotfix() ==> updating product');
                    _this.deployHotfix();
                });
            }
            else {
                console.error('ProductUpdatesComponent ==> stopAndDeployHotfix() ==> Failure in stopping product. ' + _this.errorCode);
                console.error('ProductUpdatesComponent ==> stopAndDeployHotfix() ==> Failure in stopping product. Command Output: ' + commandoutput.commandOutput);
                console.error('ProductUpdatesComponent ==> stopAndDeployHotfix() ==> Failure in stopping product. Command Error Output: ' + commandoutput.commandErrorOutput);
                _this.productStopFailure = true;
            }
        }, function (error) {
            _this.productStopRunning = false;
            _this.errorMessage = error;
            console.error('ProductUpdatesComponent ==> stopAndDeployHotfix() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.customUpdateErrorMessage = _this.errorMsgStopProduct;
            _this.updateSubscriptionErrors = true;
            //Enable navigations and start cleanup in the background
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
        });
    };
    /**
     * FUNCTION STOPS AND UPDATES THE PRODUCT
     */
    ProductUpdatesComponent.prototype.stopAndUpdateECX = function () {
        var _this = this;
        this.productStopRunning = true;
        this.updateActionsType = "stopapp";
        this.actionsService.manageAppService(this.updateActionsType)
            .subscribe(function (commandoutput) {
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                _this.productIsStopped = true;
                console.log('ProductUpdatesComponent ==> stopAndUpdateECX() ==> Product stopped. Waiting 5 sec.');
                Observable_1.Observable.interval(5000).take(1).subscribe(function () {
                    _this.productStopRunning = false;
                    console.log('ProductUpdatesComponent ==> stopAndUpdateECX() ==> updating product');
                    _this.updateECX();
                });
            }
            else {
                console.error('ProductUpdatesComponent ==> stopAndUpdateECX() ==> Failure in stopping product. ' + _this.errorCode);
                console.error('ProductUpdatesComponent ==> stopAndUpdateECX() ==> Failure in stopping product. Command Output: ' + commandoutput.commandOutput);
                console.error('ProductUpdatesComponent ==> stopAndUpdateECX() ==> Failure in stopping product. Command Error Output: ' + commandoutput.commandErrorOutput);
                _this.productStopFailure = true;
            }
        }, function (error) {
            _this.productStopRunning = false;
            _this.errorMessage = error;
            console.error('ProductUpdatesComponent ==> stopAndUpdateECX() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.customUpdateErrorMessage = _this.errorMsgStopProduct;
            _this.updateSubscriptionErrors = true;
            //Enable navigations and start cleanup in the background
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
            if (_this.manualUpdateProcess) {
                console.log('ProductUpdatesComponent ==> stopAndUpdateECX() ==> Running cleanup for manual update process');
                _this.manualUpdateCleanup();
            }
        });
    };
    /**
     * FUNCTION REBOOTS THE APPLIANCE
     */
    ProductUpdatesComponent.prototype.rebootVirtualAppliance = function () {
        var _this = this;
        this.emiService.setSystemStatus(false);
        this.applianceRebootAfterUpdateRunning = true;
        this.updateActionsType = "restart";
        this.actionsService.manageAppService(this.updateActionsType)
            .subscribe(function (commandoutput) {
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                console.log('ProductUpdatesComponent ==> rebootVirtualAppliance() ==> appliance rebooted, starting wait interval');
                Observable_1.Observable.interval(360000).take(1).subscribe(function () {
                    console.log('ProductUpdatesComponent ==> rebootVirtualAppliance() ==> interval complete');
                    _this.applianceRebootAfterUpdateRunning = false;
                    _this.applianceRebootedAfterUpdate = true;
                    _this.runSelfUpdateRestart();
                });
            }
            else {
                console.error('ProductUpdatesComponent ==> rebootVirtualAppliance() ==> ' + _this.errorCode);
                console.error('ProductUpdatesComponent ==> rebootVirtualAppliance() ==> Command Output: ' + commandoutput.commandOutput);
                console.error('ProductUpdatesComponent ==> rebootVirtualAppliance() ==> Command Error Output: ' + commandoutput.commandErrorOutput);
                _this.applianceRebootAfterUpdateRunning = false;
                _this.applianceRebootedAfterUpdateFailure = true;
                _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
                _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
            }
        }, function (error) {
            _this.applianceRebootAfterUpdateRunning = false;
            _this.errorMessage = error;
            console.error('ProductUpdatesComponent ==> rebootVirtualAppliance() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.customUpdateErrorMessage = _this.errorMsgRebootVa;
            _this.updateSubscriptionErrors = true;
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
        });
    };
    /**
     * FUNCTION RESTARTS THE PRODUCT
     */
    ProductUpdatesComponent.prototype.restartECX = function () {
        var _this = this;
        if (!this.isHotfixDeployment) {
            this.productRestartAfterUpdateRunning = true;
        }
        else {
            this.productRestartAfterHotfixDeployRunning = true;
        }
        this.updateActionsType = "startapp";
        this.actionsService.manageAppService(this.updateActionsType)
            .subscribe(function (commandoutput) {
            _this.errorCode = commandoutput.errorCode;
            if (!_this.isHotfixDeployment) {
                _this.productRestartAfterUpdateRunning = false;
            }
            else {
                _this.productRestartAfterHotfixDeployRunning = false;
            }
            if (_this.errorCode === "0") {
                if (!_this.isHotfixDeployment) {
                    _this.productRestartedAfterUpdate = true;
                }
                else {
                    _this.productRestartedAfterHotfixDeploy = true;
                }
            }
            else {
                console.error('ProductUpdatesComponent ==> restartECX() ==> ' + _this.errorCode);
                console.error('ProductUpdatesComponent ==> restartECX() ==> Command Output: ' + commandoutput.commandOutput);
                console.error('ProductUpdatesComponent ==> restartECX() ==> Command Error Output: ' + commandoutput.commandErrorOutput);
                if (!_this.isHotfixDeployment) {
                    _this.productRestartAfterUpdateFailure = true;
                }
                else {
                    _this.productRestartAfterHotfixDeployFailed = true;
                }
            }
            if (!_this.isHotfixDeployment) {
                //Check and run self-update
                if (_this.selfUpdateAvailable) {
                    _this.runSelfUpdate();
                }
                else {
                    if (_this.manualUpdateProcess) {
                        console.log('ProductUpdatesComponent ==> restartECX() ==> Running cleanup for manual update process');
                        _this.manualUpdateCleanup();
                    }
                    else {
                        _this.rebootVirtualAppliance();
                    }
                }
            }
            else {
                if (_this.manualUpdateProcess) {
                    console.log('ProductUpdatesComponent ==> restartECX() ==> Running cleanup for manual update process');
                    _this.manualUpdateCleanup();
                }
                else {
                    _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
                    _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
                }
            }
        }, function (error) {
            if (!_this.isHotfixDeployment) {
                _this.productRestartAfterUpdateRunning = false;
            }
            else {
                _this.productRestartAfterHotfixDeployRunning = false;
            }
            _this.errorMessage = error;
            console.error('ProductUpdatesComponent ==> restartECX() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.customUpdateErrorMessage = _this.errorMsgRestartProduct;
            _this.updateSubscriptionErrors = true;
            //Enable navigations and start cleanup in the background
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
            if (!_this.isHotfixDeployment) {
                if (_this.manualUpdateProcess) {
                    console.log('ProductUpdatesComponent ==> restartECX() ==> Running cleanup for manual update process');
                    _this.manualUpdateCleanup();
                }
            }
            else {
            }
        });
    };
    ProductUpdatesComponent.prototype.updateVersion = function () {
        var _this = this;
        var version = this.selectedVersion ? this.selectedVersion.version : null;
        var build = this.selectedVersion ? this.selectedVersion.build : null;
        console.log("update Version :" + version + " build " + build);
        this.productUpdatesService.updateGivenVersion(version, build)
            .subscribe(function (commandoutput) {
            if (_this.errorCode === "0") {
                console.log("update Version :  here 1 ");
                _this.updateECX();
            }
            else {
                console.error('ProductUpdatesComponent ==> updateVersion() ==> ' + _this.errorCode);
                console.error('ProductUpdatesComponent ==> updateVersion() ==> Command Output: ' + commandoutput.commandOutput);
                console.error('ProductUpdatesComponent ==> updateVersion() ==> Command Error Output: ' + commandoutput.commandErrorOutput);
                _this.updateAvailabilityCmdOutputErrorMessage = commandoutput.commandErrorOutput;
            }
        }, function (error) {
            console.log("update Version :  here 2 ");
            _this.errorMessage = error;
            console.error('ProductUpdatesComponent ==> checkECXUpdates() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.customUpdateErrorMessage = _this.errorMsgCheckUpdates;
            _this.updateSubscriptionErrors = true;
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
        });
    };
    //TO DO: Update this method to call new API
    ProductUpdatesComponent.prototype.checkECXUpdates = function () {
        var _this = this;
        this.checkUpdateRunning = true;
        this.coreService.setPluginStatus(this.emiService.getPluginName(), this.emiService.getNavigationStatusKey(), false);
        this.coreService.setPluginStatus(this.emiService.getPluginName(), this.emiService.getAdminconsoleNavigationStatusKey(), false);
        //TO DO MODIFIED ALREADY TO NEW METHOD
        this.productUpdatesService.checkUpgradeAvailability()
            .subscribe(function (commandoutput) {
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                //This should return something like [{ "version": "10.1.4", build: "380"}, { "version": "10.1.6", "build": "100"}]
                // or empty
                //Render each one as buttons in the UI for now, improve as necessary
                _this.updateVersions = JSON.parse(commandoutput.commandOutput);
                console.log(" Update Version  Begin");
                console.log(_this.updateVersions);
                console.log(" Update Version End");
                if (_this.updateVersions.length > 0) {
                    _this.updatesAvailable = true;
                    _this.updateAvailabilityCmdSuccess = true;
                }
                _this.updateAvailabilityCmdOutputMessage = commandoutput.commandOutput;
            }
            else {
                console.error('ProductUpdatesComponent ==> checkECXUpdates() ==> ' + _this.errorCode);
                console.error('ProductUpdatesComponent ==> checkECXUpdates() ==> Command Output: ' + commandoutput.commandOutput);
                console.error('ProductUpdatesComponent ==> checkECXUpdates() ==> Command Error Output: ' + commandoutput.commandErrorOutput);
                _this.updateAvailabilityCmdOutputErrorMessage = commandoutput.commandErrorOutput;
            }
            _this.showUpdateAvailabilityCmdResponseWindow = true;
            _this.checkUpdateDone = true;
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
        }, function (error) {
            _this.errorMessage = error;
            console.error('ProductUpdatesComponent ==> checkECXUpdates() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.customUpdateErrorMessage = _this.errorMsgCheckUpdates;
            _this.updateSubscriptionErrors = true;
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
        });
    };
    /**
     * FUNCTIONS RUNS SELF UPDATE
     */
    ProductUpdatesComponent.prototype.runSelfUpdate = function () {
        var _this = this;
        console.log('ProductUpdatesComponent ==> runSelfUpdate() ==> ');
        this.adminConsoleUrl = this.coreService.getCookie("adminconsole_ms_url");
        this.selfUpdateRunning = true;
        this.productUpdatesService.startSelfUpdate();
        if (this.rebootAppliance) {
            console.log('ProductUpdatesComponent ==> runSelfUpdate() ==> appliance reboot use case');
            Observable_1.Observable.interval(300000).take(1).subscribe(function () {
                console.log('ProductUpdatesComponent ==> runSelfUpdate() ==> interval complete');
                _this.selfUpdateRunning = false;
                if (_this.manualUpdateProcess) {
                    console.log('ProductUpdatesComponent ==> runSelfUpdate() ==> Running cleanup for manual update process');
                    _this.manualUpdateCleanup();
                }
                else {
                    _this.rebootVirtualAppliance();
                }
            });
        }
        else {
            Observable_1.Observable.interval(300000).take(1).subscribe(function () {
                console.log('ProductUpdatesComponent ==> runSelfUpdate() ==> interval complete');
                _this.selfUpdateRunning = false;
                if (_this.manualUpdateProcess) {
                    console.log('ProductUpdatesComponent ==> runSelfUpdate() ==> Running cleanup for manual update process');
                    _this.manualUpdateCleanup();
                }
                _this.runSelfUpdateRestart();
            });
        }
    };
    ProductUpdatesComponent.prototype.runSelfUpdateRestart = function () {
        var _this = this;
        console.log('ProductUpdatesComponent ==> runSelfUpdateRestart() ==>');
        this.selfUpdateRestart = true;
        Observable_1.Observable.interval(10000).take(1).subscribe(function () {
            console.log('ProductUpdatesComponent ==> runSelfUpdateRestart() ==> reloading');
            _this.productUpdatesService.selfUpdateLogout(_this.adminConsoleUrl);
        });
    };
    /**
     * FUNCTION DEPLOYS HOTFIXES
     */
    ProductUpdatesComponent.prototype.deployHotfix = function () {
        var _this = this;
        console.log('ProductUpdatesComponent ==> deployHotfix() ==>');
        this.hotfixDeploymentStarted = true;
        this.hotfixDeploymentRunning = true;
        this.productUpdatesService.deployHotfix(this.updateImageDirectory + '/' + this.updateImageFilename)
            .subscribe(function (commandoutput) {
            _this.hotfixDeploymentRunning = false;
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                _this.hotfixDeploymentSuccess = true;
                _this.restartECX();
            }
            else {
                _this.hotfixDeploymentFailure = true;
                console.error('ProductUpdatesComponent ==> deployHotfix() ==> ' + _this.errorCode);
                console.error('ProductUpdatesComponent ==> deployHotfix() ==> Command Output: ' + commandoutput.commandOutput);
                console.error('ProductUpdatesComponent ==> deployHotfix() ==> Command Error Output: ' + commandoutput.commandErrorOutput);
                _this.restartECX();
            }
        }, function (error) {
            _this.errorMessage = error;
            console.error('ProductUpdatesComponent ==> deployHotfix() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.customUpdateErrorMessage = _this.errorMsgDeployHotfix;
            _this.updateSubscriptionErrors = true;
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
        });
    };
    /**
     * FUNCTION UPDATES THE PRODUCT
     */
    ProductUpdatesComponent.prototype.updateECX = function () {
        var _this = this;
        console.log('ProductUpdatesComponent ==> updateECX() ==>');
        this.initWebsocket('product');
        this.ecxUpdateRunning = true;
        this.showEcxUpdateCmdResponseWindow = false;
        this.progressString.push(this.contactUpdateServer);
        this.productUpdatesService.startEcxUpdate()
            .subscribe(function (commandoutput) {
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                if (_this.manualUpdateProcess) {
                    console.log('ProductUpdatesComponent ==> updateECX() ==> run selfupdate for manual update process ');
                    _this.selfUpdateAvailable = true;
                }
                //REBOOT APPLIANCE FOR EVERY UPDATE
                //THIS IS THE CURRENT DEFAULT PATH
                console.log(commandoutput.commandOutput);
                if (commandoutput.commandOutput.includes("Reboot=true")) {
                    _this.rebootAppliance = true;
                }
                _this.ecxUpdateCmdSuccess = true;
                _this.ecxUpdateCmdOutputMessage = commandoutput.commandOutput;
                _this.showEcxUpdateCmdResponseWindow = true;
                _this.ecxUpdateDone = true;
                if (_this.rebootAppliance) {
                    //PRODUCT IS NOT RESTARTED IN THIS CASE BECAUSE APPLIANCE IS BEING REBOOTED AFTER SELF-UPDATE
                    if (_this.selfUpdateAvailable) {
                        _this.runSelfUpdate();
                    }
                    else {
                        if (_this.manualUpdateProcess) {
                            console.log('ProductUpdatesComponent ==> updateECX() ==> Running cleanup for manual update process');
                            _this.manualUpdateCleanup();
                        }
                        else {
                            _this.rebootVirtualAppliance();
                        }
                    }
                }
                else {
                    _this.restartECX();
                }
            }
            else {
                console.error('ProductUpdatesComponent ==> updateECX() ==> ' + _this.errorCode);
                console.error('ProductUpdatesComponent ==> updateECX() ==> Command Output: ' + commandoutput.commandOutput);
                console.error('ProductUpdatesComponent ==> updateECX() ==> Command Error Output: ' + commandoutput.commandErrorOutput);
                _this.ecxUpdateCmdOutputErrorMessage = commandoutput.commandErrorOutput;
                _this.showEcxUpdateCmdResponseWindow = true;
                if (_this.manualUpdateProcess) {
                    console.log('ProductUpdatesComponent ==> updateECX() ==> Running cleanup for manual update process');
                    _this.manualUpdateCleanup();
                }
                else {
                    _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
                    _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
                }
            }
        }, function (error) {
            _this.errorMessage = error;
            console.error('ProductUpdatesComponent ==> updateECX() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.customUpdateErrorMessage = _this.errorMsgProductUpdate + ' ' + _this.errorMessage;
            _this.updateSubscriptionErrors = true;
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
            if (_this.manualUpdateProcess) {
                console.log('ProductUpdatesComponent ==> updateECX() ==> Running cleanup for manual update process');
                _this.manualUpdateCleanup();
            }
        });
        this.progressString.push(this.startingProductUpdate);
        this.progressString.push(this.startedProductUpdate);
    };
    /**
     * FUNCTION CLEANS UP FILES AND ENVIRONMENT SETUPS ON THE APPLIANCE THAT ARE
     * DONE DURING THE PRODUCT UPDATE (OR) OS UPDATE (OR) HOTIFIX PROCESS
     */
    ProductUpdatesComponent.prototype.manualUpdateCleanup = function () {
        var _this = this;
        console.log('ProductUpdatesComponent ==> manualUpdateCleanup() ==>');
        this.showNoInternetCleanupRunning = true;
        this.productUpdatesService.manualUpdateCleanupService(this.updateImageFilename, this.updateImageDirectory)
            .subscribe(function (commandoutputupdateimage) {
            _this.showNoInternetCleanupRunning = false;
            _this.errorCode = commandoutputupdateimage.errorCode;
            if (_this.errorCode === "0") {
                _this.showNoInternetCleanupSuccess = true;
            }
            else {
                console.error('ProductUpdatesComponent ==> manualUpdateCleanup() ==> ' + _this.errorCode);
                console.error('ProductUpdatesComponent ==> manualUpdateCleanup() ==> Command Output: ' + commandoutputupdateimage.commandOutput);
                console.error('ProductUpdatesComponent ==> manualUpdateCleanup() ==> Command Error Output: ' + commandoutputupdateimage.commandErrorOutput);
                _this.showNoInternetCleanupFailure = true;
            }
            if (!_this.isHotfixDeployment) {
                if (!_this.isOSUpdate) {
                    if (_this.rebootAppliance) {
                        _this.rebootVirtualAppliance();
                    }
                    else {
                        if (_this.selfUpdateAvailable) {
                            _this.runSelfUpdateRestart();
                        }
                        else {
                            console.log('ProductUpdatesComponent ==> manualUpdateCleanup() ==> application will not be restarted.');
                        }
                    }
                }
                else {
                    _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
                    _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
                }
            }
            else {
                _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
                _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
            }
        }, function (error) {
            _this.showNoInternetCleanupRunning = false;
            _this.errorMessage = error;
            console.error('ProductUpdatesComponent ==> manualUpdateCleanup() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.customUpdateErrorMessage = _this.errorMsgCleanup;
            _this.updateSubscriptionErrors = true;
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
        });
    };
    ProductUpdatesComponent.prototype.checkInternet = function () {
        var _this = this;
        this.checkingInternetConnectivity = true;
        this.coreService.setPluginStatus(this.emiService.getPluginName(), this.emiService.getNavigationStatusKey(), false);
        this.coreService.setPluginStatus(this.emiService.getPluginName(), this.emiService.getAdminconsoleNavigationStatusKey(), false);
        this.productUpdatesService.checkEcxInternetAvailability()
            .subscribe(function (commandoutput) {
            _this.checkingInternetConnectivity = false;
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                _this.showInternetDialog = true;
                _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
                _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
                if (!_this.checkUpdateDone) {
                    _this.checkECXUpdates();
                }
            }
            else {
                console.error('ProductUpdatesComponent ==> checkInternet() ==> ' + _this.errorCode);
                console.error('ProductUpdatesComponent ==> checkInternet() ==> Command Output: ' + commandoutput.commandOutput);
                console.error('ProductUpdatesComponent ==> checkInternet() ==> Command Error Output: ' + commandoutput.commandErrorOutput);
                _this.errorMessage = commandoutput.commandErrorOutput;
                _this.checkInternetAvailabilityErrorMessage = _this.errorCode + '\n' + commandoutput.commandOutput + '\n' + commandoutput.commandErrorOutput;
                _this.showNoInternetDialog = true;
                _this.showNoInternetDialogUploadForm = true;
                _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
                _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
            }
        }, function (error) {
            _this.errorMessage = error;
            console.error('ProductUpdatesComponent ==> checkInternet() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.customUpdateErrorMessage = _this.errorMsgInternetConnec;
            _this.updateSubscriptionErrors = true;
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
        });
    };
    ProductUpdatesComponent.prototype.runManualUpdate = function () {
        this.showInternetDialog = false;
        this.showNoInternetDialog = true;
        this.showNoInternetDialogUploadForm = true;
        this.showNoInternetDialogUploadFormDefaultHeader = false;
        this.checkInternetAvailabilityErrorMessage = '';
    };
    __decorate([
        core_1.ViewChild("confirmUpdateDialog"), 
        __metadata('design:type', confirmation_component_1.ConfirmationDialog)
    ], ProductUpdatesComponent.prototype, "confirmUpdateDialog", void 0);
    __decorate([
        core_1.ViewChild("confirmManualUpdateDialog"), 
        __metadata('design:type', Object)
    ], ProductUpdatesComponent.prototype, "confirmManualUpdateDialog", void 0);
    ProductUpdatesComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'productupdates',
            templateUrl: '../views/productupdates.component.html'
        }), 
        __metadata('design:paramtypes', [core_service_1.CoreService, productupdates_service_1.ProductUpdatesService, actions_service_1.ActionsService, emi_service_1.EMIService, maputility_service_1.MapUtilityService, core_2.TranslateService])
    ], ProductUpdatesComponent);
    return ProductUpdatesComponent;
}());
exports.ProductUpdatesComponent = ProductUpdatesComponent;
