"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var Observable_1 = require('rxjs/Observable');
var core_service_1 = require('ng2-catalogic/core/service/core.service');
var emi_service_1 = require('../../emi.service');
var ProductUpdatesService = (function () {
    function ProductUpdatesService(http, coreService, emiService) {
        this.http = http;
        this.coreService = coreService;
        this.emiService = emiService;
        this.deployHotfixUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/hotfix';
        this.startOsUpdateUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/updateos';
        this.startEcxUpdateUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/update?action=full';
        this.checkEcxUpdateAvailableUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/checkecxupdate';
        //To do
        this.checkUpgradeAvailableUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/checkupgrade';
        this.TOPIC = '/topic/ecxupdateprogress';
        this.OSTOPIC = '/topic/osupdateprogress';
        this.BROKER = '/topic';
        this.uploadUpdateImageUrl = this.emiService.getAdminconsoleEmiEndpointsUrlLargeFileUpload() + '/api/uploadupdateimage';
        this.cleanupUpdateImageUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/cleanupupdateimage';
        this.checkInternetAvailabilityUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/checkinternetavailability';
        this.selfUpdateUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/updateac';
        this.yumConfigure = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/configureyum';
    }
    ProductUpdatesService.prototype.init = function () { };
    ProductUpdatesService.prototype.openSocket = function (socketType) {
        console.log('ProductUpdatesService ==> openSocket ==> ' + socketType);
        if (socketType === 'product') {
            return this.coreService.openStompWebSocket(this.emiService.getAdminconsoleEmiEndpointsUrl() + "/ecx-update-progress", this.TOPIC, this.BROKER);
        }
        else if (socketType === 'os') {
            return this.coreService.openStompWebSocket(this.emiService.getAdminconsoleEmiEndpointsUrl() + "/ecx-update-progress", this.OSTOPIC, this.BROKER);
        }
    };
    ProductUpdatesService.prototype.startOsUpdate = function () {
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.post(this.startOsUpdateUrl, null, options)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    ProductUpdatesService.prototype.deployHotfix = function (hflocation) {
        var formData = new FormData();
        formData.append('action', 'hfdeploy');
        formData.append('hflocation', hflocation);
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.post(this.deployHotfixUrl, formData, options)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    ProductUpdatesService.prototype.startEcxUpdate = function () {
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.post(this.startEcxUpdateUrl, null, options)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    ProductUpdatesService.prototype.startSelfUpdate = function () {
        this.http.post(this.selfUpdateUrl, null)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError)
            .subscribe({ error: function (e) { return console.error('ProductUpdatesService ==> startSelfUpdate() ==> ' + e); } });
    };
    ProductUpdatesService.prototype.checkEcxUpdateAvailability = function () {
        var headers = new http_1.Headers();
        headers.append('Content-Type', 'application/json');
        headers.append('Accept', 'application/json');
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.get(this.checkEcxUpdateAvailableUrl, options)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    ProductUpdatesService.prototype.checkUpgradeAvailability = function () {
        var headers = new http_1.Headers();
        headers.append('Content-Type', 'application/json');
        headers.append('Accept', 'application/json');
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.get(this.checkUpgradeAvailableUrl, options)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    ProductUpdatesService.prototype.checkEcxInternetAvailability = function () {
        var headers = new http_1.Headers();
        headers.append('Content-Type', 'application/json');
        headers.append('Accept', 'application/json');
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.get(this.checkInternetAvailabilityUrl, options)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    ProductUpdatesService.prototype.uploadUpdateImage = function (fileInput) {
        var file = fileInput;
        var formData = new FormData();
        formData.append('file', file, file.name);
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.post(this.uploadUpdateImageUrl, formData, options)
            .map(this.extractDataCommandOutputUpdateImage)
            .catch(this.handleError);
    };
    ProductUpdatesService.prototype.manualUpdateCleanupService = function (updateimagefilename, updateimagedirectory) {
        var formData = new FormData();
        formData.append('updateimagefilename', updateimagefilename);
        formData.append('updateimagedirectory', updateimagedirectory);
        return this.http.post(this.cleanupUpdateImageUrl, formData)
            .map(this.extractDataCommandOutputUpdateImage)
            .catch(this.handleError);
    };
    ProductUpdatesService.prototype.selfUpdateLogout = function (adminConsoleUrl) {
        this.browserUrl = this.coreService.getCookie("adminconsole_portal_url") + "/api/endeavour/session";
        this.coreService.setSessionId(undefined, this.browserUrl);
        window.sessionId = undefined;
        this.deleteCreatedCookies();
        console.log('ProductUpdatesService ==> selfUpdateLogout() ==> reloading application ' + adminConsoleUrl + ' !');
        window.location.href = adminConsoleUrl;
    };
    //This method will inform backend to configure yum
    ProductUpdatesService.prototype.updateGivenVersion = function (version, build) {
        var formData = new FormData();
        formData.append('version', version);
        formData.append('build', build);
        console.log('Venki updateGivenVersion ==> version ' + version + ' build :' + build + '--done-' + "formdata" + formData);
        return this.http.post(this.yumConfigure, formData)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    /**
     * DELETE COOKIES
     * (Created cookies needs to be deleted here)
     * Called during admin console update before reloading the application
     */
    ProductUpdatesService.prototype.deleteCreatedCookies = function () {
        this.coreService.deleteCookie("adminconsole_portal_url");
        this.coreService.deleteCookie("adminconsole_ms_url");
        this.coreService.deleteCookie("adminconsole_emims_url");
        this.coreService.deleteCookie("adminconsole_company_name");
        this.coreService.deleteCookie("adminconsole_product_name");
    };
    /**
     * EXTRACT DATA
     */
    ProductUpdatesService.prototype.extractDataCommandOutputUpdateImage = function (res) {
        var body = res.json();
        return body.commandoutputupdateimage || {};
    };
    ProductUpdatesService.prototype.extractDataCommandOutput = function (res) {
        var body = res.json();
        return body.commandoutput || {};
    };
    /**
     * HANDLE ERRORS
     */
    ProductUpdatesService.prototype.handleError = function (error) {
        // In a real world app, we might use a remote logging infrastructure
        var errMsg;
        if (error instanceof http_1.Response) {
            var body = error.json() || '';
            if (body.message !== undefined && body.message !== null) {
                if (body.message === "SessionId Timeout") {
                    errMsg = "SessionIdTimeout";
                }
                else {
                    errMsg = body.message;
                }
            }
            else {
                var err = body.error || JSON.stringify(body);
                errMsg = error.status + " - " + (error.statusText || '') + " " + err;
            }
        }
        else {
            errMsg = error.message ? error.message : error.toString();
        }
        console.error('ProductUpdatesService ==> handleError() ==> ' + errMsg);
        return Observable_1.Observable.throw(errMsg);
    };
    ProductUpdatesService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http, core_service_1.CoreService, emi_service_1.EMIService])
    ], ProductUpdatesService);
    return ProductUpdatesService;
}());
exports.ProductUpdatesService = ProductUpdatesService;
