"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/common/http');
var core_2 = require('@ngx-translate/core');
var core_3 = require('@ngx-translate/core');
var locale_service_1 = require('./locale.service');
var translation_loader_1 = require('./translation-loader');
function createTranslateLoader(http) {
    return new translation_loader_1.TranslationLoader(http, 'plugins/emi/i18n/emi_', '.json');
}
exports.createTranslateLoader = createTranslateLoader;
var translationOptions = {
    loader: {
        provide: core_2.TranslateLoader,
        useFactory: (createTranslateLoader),
        deps: [http_1.HttpClient]
    }
};
var TranslationModule = (function () {
    function TranslationModule(translate, localeSvc) {
        this.translate = translate;
        this.localeSvc = localeSvc;
        var langID = localeSvc.appLangID;
        translate.addLangs([langID]);
        translate.setDefaultLang(langID);
        translate.use(langID);
        console.log('EMI ==> TranslationModule ==> Instantiated langID: ' + langID);
    }
    TranslationModule = __decorate([
        core_1.NgModule({
            imports: [
                http_1.HttpClientModule,
                core_2.TranslateModule.forRoot(translationOptions)
            ],
            exports: [
                core_2.TranslateModule
            ],
            providers: [
                core_3.TranslateService,
                locale_service_1.LocaleService
            ]
        }), 
        __metadata('design:paramtypes', [core_3.TranslateService, locale_service_1.LocaleService])
    ], TranslationModule);
    return TranslationModule;
}());
exports.TranslationModule = TranslationModule;
